System.Data 1.0.5000.0 2.0.0.0 System.Data.Common.DbDataReader

To create an , you must call the method of the object, instead of directly using a constructor.

While the is being used, the associated is busy serving the , and no other operations can be performed on the other than closing it. This is the case until the method of the is called. For example, you cannot retrieve output parameters until after you call .

Changes made to a result set by another process or thread while data is being read may be visible to the user of the . However, the precise behavior is both driver and timing dependent.

and are the only properties that you can call after the is closed. Sometimes, you must call before you can call .

Provides a way of reading a forward-only stream of data rows from a data source. This class cannot be inherited.

- Method
  System.Void

  You must explicitly call the method when you are finished using the to use the associated for any other purpose.

  Do not call Close or Dispose on a Connection, a DataReader, or any other managed object in the Finalize method of your class. In a finalizer, you should only release unmanaged resources that your class owns directly. If your class does not own any unmanaged resources, do not include a Finalize method in your class definition. For more information, see Garbage Collection.

  Closes the object.

  1.0.5000.0
  2.0.0.0
- Property
  System.Int32 To be added.

  The outermost table has a depth of zero.

  Gets a value that indicates the depth of nesting for the current row.

  1.0.5000.0
  2.0.0.0
- Method
  System.Void `` To be added. To be added. To be added. 2.0.0.0
- Property
  System.Int32 To be added.

  Includes hidden fields. Use to exclude hidden fields.

  After you execute a query that does not return rows, returns 0.

  Gets the number of columns in the current row.

  1.0.5000.0
  2.0.0.0
- Method
  System.Void To be added. To be added. 1.0.5000.0
- Method
  System.Boolean ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a Boolean.

  A Boolean that is the value of the column.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Byte ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a byte.

  The value of the specified column as a byte.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int64 `` `` `` `` ``

  returns the number of available bytes in the field. Most of the time this is the exact length of the field. However, the number returned may be less than the true length of the field if has already been used to obtain bytes from the field. This may be the case, for example, if the is reading a large data structure into a buffer. For more information, see the SequentialAccess setting for .

  If you pass a buffer that is a null value, returns the length of the field in bytes.

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  No exception will be thrown if the value of is outside the array. No data will be read and the method will return 0.

  Reads a stream of bytes from the specified column offset into the buffer as an array, starting at the particular buffer offset.

  The actual number of bytes read.

  The zero-based column ordinal. The index within the field where the read operation is to start. The buffer into which to read the stream of bytes. The index within the where the write operation is to start. The number of bytes to read. 1.0.5000.0 2.0.0.0
- Method
  System.Char ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a character.

  The value of the specified column as a character.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int64 `` `` `` `` ``

  returns the number of available characters in the field. Most of the time this is the exact length of the field. However, the number returned may be less than the true length of the field if has already been used to obtain characters from the field. This may be the case, for example, if the is reading a large data structure into a buffer. For more information, see the SequentialAccess setting for .

  If you pass a buffer that is a null value, returns the length of the field in characters.

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  No exception will be thrown if the value of is outside the array. No data will be read and the method will return 0.

  Reads a stream of characters from the specified column offset into the buffer as an array, starting at the particular buffer offset.

  The actual number of characters read.

  The zero-based column ordinal. The index within the row where the read operation is to start. The buffer into which to copy data. The index within the where the write operation is to start. The number of characters to read. 1.0.5000.0 2.0.0.0
- Method
  System.Data.IDataReader `` To be added. To be added. To be added. To be added. 1.0.5000.0 System.ComponentModel.EditorBrowsable(State=System.ComponentModel.EditorBrowsableState.Never)
- Method
  System.String `` To be added.

  Gets the name of the source data type.

  The name of the source data type.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.DateTime `` To be added.

  Gets the value of the specified column as a object.

  The value of the specified column as a object.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.DateTime ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a object.

  The value of the specified column as a object.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Decimal ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  Call to look for null values before calling this method.

  has a maximum precision of 28. Attempting to retrieve decimal data with a larger precision will cause an exception. One solution would be to change the query to cast the decimal type to either a smaller datatype or convert to string or binary.

  Gets the value of the specified column as a object.

  The value of the specified column as a object.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Double ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a double-precision floating-point number.

  The value of the specified column as a double-precision floating-point number.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Collections.IEnumerator

  Although you can use this method to retrieve an explicit enumerator, in languages that support a foreach construct, it is simpler to use the looping construct directly in order to iterate through the rows in the data reader.

  Returns an that can be used to iterate through the rows in the data reader.

  An that can be used to iterate through the rows in the data reader.

  2.0.0.0
- Method
  System.Type `` To be added.

  Gets the that is the data type of the object.

  The that is the data type of the object.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Single ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported then the method call will fail.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a single-precision floating-point number.

  The value of the specified column as a single-precision floating-point number.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Guid ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a globally unique identifier (GUID).

  The value of the specified column as a GUID.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int16 ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a 16-bit signed integer.

  The value of the specified column as a 16-bit signed integer.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int32 ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a 32-bit signed integer.

  The value of the specified column as a 32-bit signed integer.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int64 ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a 64-bit signed integer.

  The value of the specified column as a 64-bit signed integer.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.String `` To be added.

  Gets the name of the specified column.

  A string that is the name of the specified column.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int32 ``

  performs a case-sensitive lookup first. If it fails, a second case-insensitive search is made. The method throws an IndexOutOfRange exception if the zero-based column ordinal is not found.

  is kana-width insensitive.

  Because ordinal-based lookups are more efficient than named lookups, it is inefficient to call within a loop. Instead, call one time and then assign the results to an integer variable for use within the loop.

  Gets the column ordinal, given the name of the column.

  The zero-based column ordinal.

  The name of the column. 1.0.5000.0 2.0.0.0
- Method
  System.Data.DataTable

  The method returns metadata about each column in the following order:

  DataReader column

  Description

  ColumnName

  The name of the column; this might not be unique. If the column name cannot be determined, a null value is returned. This name always reflects the most recent naming of the column in the current view or command text.

  ColumnOrdinal

  The zero-based ordinal of the column. This column cannot contain a null value.

  ColumnSize

  The maximum possible length of a value in the column. For columns that use a fixed-length data type, this is the size of the data type.

  NumericPrecision

  If is a numeric data type, this is the maximum precision of the column. The precision depends on the definition of the column. If is not a numeric data type, do not use the data in this column. If the underlying ODBC driver returns a precision value for a non-numeric data type, this value is used in the schema table.

  NumericScale

  If is , the number of digits to the right of the decimal point. Otherwise, this is a null value. If the underlying ODBC driver returns a precision value for a non-numeric data type, this value is used in the schema table.

  DataType

  Maps to the common language runtime type of .

  ProviderType

  The underlying driver type.

  IsLong

  true if the column contains a Binary Long Object (BLOB) that contains very long data. The definition of very long data is driver-specific.

  AllowDBNull

  true if the consumer can set the column to a null value or if the driver cannot determine whether the consumer can set the column to a null value. Otherwise, false. A column may contain null values, even if it cannot be set to a null value.

  IsReadOnly

  true if the column cannot be modified; otherwise false.

  IsRowVersion

  Set if the column contains a persistent row identifier that cannot be written to, and has no meaningful value except to identity the row.

  IsUnique

  true: No two rows in the base table (the table returned in BaseTableName) can have the same value in this column. IsUnique is guaranteed to be true if the column represents a key by itself or if there is a constraint of type UNIQUE that applies only to this column.

  false: The column can contain duplicate values in the base table. The default for this column is false.

  IsKey

  true: The column is one of a set of columns in the rowset that, taken together, uniquely identify the row. The set of columns with IsKey set to true must uniquely identify a row in the rowset. There is no requirement that this set of columns is a minimal set of columns. This set of columns may be generated from a base table primary key, a unique constraint, or a unique index.

  false: The column is not required to uniquely identify the row.

  IsAutoIncrement

  true if the column assigns values to new rows in fixed increments; otherwise false. The default for this column is false.

  BaseSchemaName

  The name of the schema in the data source that contains the column. NULL if the base catalog name cannot be determined. The default for this column is a null value.

  BaseCatalogName

  The name of the catalog in the data store that contains the column. NULL if the base catalog name cannot be determined. The default for this column is a null value.

  BaseTableName

  The name of the table or view in the data store that contains the column. A null value if the base table name cannot be determined. The default of this column is a null value.

  BaseColumnName

  The name of the column in the data store. This might be different from the column name returned in the ColumnName column if an alias was used. A null value if the base column name cannot be determined or if the rowset column is derived, but not identical to, a column in the data store. The default for this column is a null value.

  A row is returned for every column in the results set.

  The .NET Framework Data Provider for ODBC assumes that metadata information is available from an ODBC driver after one of SQLPrepare, SQLExecute, or SQLExecuteDirect functions are called. For "SchemaOnly" command behavior to work correctly, SQLPrepare must return the required metadata information. Not all ODBC drivers support this function or return metadata information. In these cases, part or all of the information in the SchemaTable will be missing. After calling SQLPrepare, The data provider calls the ODBC SQLColAttribute function to find the metadata information related to each column in the query results (for example, IsLong, IsUnique, AllowDBNull, BaseTableName, BaseColumnName). If the underlying driver does not return some of this information, the corresponding values in the SchemaTable will not be set correctly.

  The .NET Framework Data Provider for ODBC also calls SQLPrimaryKeys to retrieve the key information for every table. If the underlying ODBC driver does not support this function, the data provider calls SQLStatistics and chooses one of the unique indexes as the primary key for the table. This may not always give the results that you want.

  needs the correct identification of the primary keys of the table in order to work correctly. If the BaseTableName is not returned for every column in the query results, the .NET Framework Data Provider for ODBC tries to parse the SQL statement to find the table names involved in the query. This works with UPDATE, INSERT, DELETE and simple SELECT statements, but not with stored procedures or SELECT statements based on joins. If some or all the schema information is missing from this table, the will not work correctly, because it has insufficient schema information to automatically generate the correct INSERT, UPDATE, or DELETE statements.

  To make sure that metadata columns return the correct information, you must call with the behavior parameter set to KeyInfo. Otherwise, some of the columns in the schema table may return default, null, or incorrect data.

  When you use ODBC.NET to Oracle via the ODBC driver, aliased key columns are not recognized as keys. This affects the IsKey and IsUnique columns in the schema table of the OdbcDataReader. It also affects the OdbcCommandBuilder's ability to generate updating logic. Consider not using an alias for a primary key column.

  The Microsoft Jet ODBC driver always returns unique index and primary key columns as nullable regardless of whether they are nullable or not. The driver also does not return primary key information; it only returns a list of unique indexes and their columns, including primary key columns, without differentiating among them.

  Returns a that describes the column metadata of the .

  A that describes the column metadata.

  1.0.5000.0
  2.0.0.0
- Method
  System.String ``

  Conversions are performed based on the underlying capabilities of the ODBC driver. If the conversion is not supported, the method call fails.

  Call to look for null values before calling this method.

  Gets the value of the specified column as a .

  The value of the specified column as a .

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.TimeSpan `` To be added.

  Gets the value of the specified column as a object.

  The value of the specified column as a object.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Object ``

  This method returns for null database columns.

  Gets the value of the column at the specified ordinal in its native format.

  The value to return.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Method
  System.Int32 ``

  For most applications, the method provides an efficient means for retrieving all columns, instead of retrieving each column individually.

  You can pass an array that contains fewer than the number of columns that are contained in the resulting row. Only the amount of data the array holds is copied to the array. You can also pass an array whose length is more than the number of columns that are contained in the resulting row.

  This method returns for null database columns.

  Populates an array of objects with the column values of the current row.

  The number of instances of in the array.

  An array of type into which to copy the attribute columns. 1.0.5000.0 2.0.0.0
- Property
  System.Boolean To be added. To be added.

  Gets a value that indicates whether the contains one or more rows.

  1.0.5000.0
  2.0.0.0
- Property
  System.Boolean To be added.

  and are the only properties that you can call after the is closed.

  Indicates whether the is closed.

  1.0.5000.0
  2.0.0.0
- Method
  System.Boolean ``

  To avoid raising an error, call this method to look for null column values before calling the typed Get methods (for example, , , and so on).

  Gets a value that indicates whether the column contains nonexistent or missing values.

  true if the specified column value is equivalent to ; otherwise false.

  The zero-based column ordinal. 1.0.5000.0 2.0.0.0
- Property
  System.Object `` To be added. To be added. To be added. To be added. 1.0.5000.0 2.0.0.0
- Property
  System.Object `` To be added. To be added. To be added. To be added. 1.0.5000.0 2.0.0.0
- Method
  System.Boolean

  Used to process multiple results that can be generated by executing batch SQL statements.

  By default, the is positioned on the first result.

  Advances the to the next result when reading the results of batch SQL statements.

  true if there are more result sets; otherwise false.

  1.0.5000.0
  2.0.0.0
- Method
  System.Boolean

  The default position of the is before the first record. Therefore, you must call to start accessing any data.

  While the is being used, the associated is busy serving it until you call .

  Advances the to the next record.

  true if there are more rows; otherwise false.

  1.0.5000.0
  2.0.0.0
- Property
  System.Int32 To be added.

  The property is not set until all rows are read and you close the .

  The value of this property is cumulative. For example, if two records are inserted in batch mode, the value of will be 2.

  and are the only properties that you can call after the is closed.

  Gets the number of rows changed, inserted, or deleted by execution of the SQL statement.

  1.0.5000.0
  2.0.0.0
- Method
  1.0.5000.0
  System.Collections.IEnumerator To be added. To be added. To be added.
- Method
  1.0.5000.0
  System.Void To be added. To be added.